:- ['H164.508.pl'].

%% Uses and disclosures to carry out treatment, payment or health care operations.
permitted_by_164_506(A) :-
  permitted_by_164_506_a(A);
  permitted_by_164_506_b(A);
  permitted_by_164_506_c(A).

permitted_by_164_506_a(A) :-
%Standard permitted uses and disclosures
  \+ require_authorization_by_164_508(A),
  is_from_coveredEntity(A),
  is_for_eitherPurpose(A),
  permitted_by_164_506_c(A).
  
permitted_by_164_506_b(A) :-
%Consent for uses and disclosures permitted
  is_for_eitherPurpose(A),
  is_consentedby_about(A).  

permitted_by_164_506_c(A) :-
%Implementation Specification
  permitted_by_164_506_c_1(A);
  permitted_by_164_506_c_2(A);
  permitted_by_164_506_c_3(A);
  permitted_by_164_506_c_4(A);
  permitted_by_164_506_c_5(A).

permitted_by_164_506_c_1(A) :-
  is_for_eitherPurpose(A),
  is_phi(A),
  is_msg_to_within(A).

permitted_by_164_506_c_2(A) :-
  is_for_treatment(A),
  is_phi(A),
  is_to_healthCareProvider(A).

permitted_by_164_506_c_3(A) :-
  is_for_payment(A),
  is_phi(A),
  satisfy_164_506_c_3(A).

satisfy_164_506_c_3(A) :-
  is_to_healthCareProvider(A);
  is_to_coveredEntity(A).

permitted_by_164_506_c_4(A) :-
  debug('164.506.c.4: How to ensure that its a diff covered entitiy?'),
  is_to_coveredEntity(A), 
  is_for_healthCareOperations(A),
  %pertains_to(A),
  is_msg_about_to_inRelation(A).

satisfy_164_506_c_4(A) :-
  permitted_by_164_506_c_4_i(A);
  permitted_by_164_506_c_4_ii(A).

permitted_by_164_506_c_4_i(A) :-
  debug('164.506.c.4.i: Could not figure out this para'),
  is_for_definitionOfHealthCareOperations(A).

permitted_by_164_506_c_4_ii(A) :-
  is_for_healthCareFraudAbuseDetection(A);
  is_for_compliance(A).
  
%place holder
permitted_by_164_506_c_5(A) :-
  debug('164.506_c_5: Not Implemented yet').

